//////////////////////////////////////////////////////////////////////
//
//  Copyright:
//        Your Copyright goes here., (c) 2000-2012. All rights reserved.
//
//  Contents:
//        This is a standard hybride mode exe.
//
//////////////////////////////////////////////////////////////////////
#include "Common.ch"
#include "Xbp.ch"
#include "Class.ch"

#pragma library( "adac20b.lib" )
#pragma library( "xppui2.lib" )

PROCEDURE Main
 LOCAL aObjs := NIL
 LOCAL oBrowse

  SetColor( "N/W+" )
  CLS
  SetAppWindow():UseShortcuts := .T.

  SET DEFAULT TO u:\source\xpp\samples\shark\data\misc
  USE parts

  // Ermitteln der Menge als Array von DataObjekten
  SELECT partno, partname, sellprice FROM parts WHERE sellprice < 200 INTO OBJECTs aObjs

  // Hinzufgen spezifischer Information (z.B. Skonto,Mwstr....)
  AEval( aObjs, {|o,nElem| o:ORDINAL:=nElem, o:DefineMethod("IsRamsch","CheckRamschStatus")} )

  // Anzeigen der Menge
  oBrowse := GUIBrowseObjects( aObjs, SetAppWindow(), 20, 20, 600, 360 )

  SetAppWindow():ShowModal( oBrowse )

RETURN


#define BRWDATA(x)   x:Cargo[1]
#define BRWRECNO(x)  x:Cargo[2]

FUNCTION GUIBrowseObjects( aObjs, oParent, nX, nY, nWidth, nHeight )
 LOCAL oBrowse
 LOCAL i
 LOCAL aNames

   oBrowse := XbpBrowse():New( oParent )
   oBrowse:Cargo         := {aObjs,1}
   oBrowse:SkipBlock     := {|nSkip,oBrowse| DoSkip(nSkip,oBrowse) }
   oBrowse:GoBottomBlock := {|| BRWRECNO(oBrowse) := Len(aObjs) }
   oBrowse:GoTopBlock    := {|| BRWRECNO(oBrowse) := 1 }
   oBrowse:PosBlock      := {|| BRWRECNO(oBrowse) }
   oBrowse:PhyPosBlock   := {|| BRWRECNO(oBrowse) }
   oBrowse:LastPosBlock  := {|| Len(aObjs) }
   oBrowse:FirstPosBlock := {|| 1 }
   oBrowse:CursorMode    := XBPBRW_CURSOR_ROW
   oBrowse:Create( ,, {nX,nY}, {nWidth,nHeight},, .F. )

   // Ermitteln des aktuellen Artikelzustands
   // (Info aus Tabelle plus evtl. durch Business-
   // logik hingefgte Elemente) und erzeugen
   // Browserspalte fr jedes Element
   aNames := aObjs[1]:ClassDescribe( CLASS_DESCR_MEMBERS )
   FOR i:=1 TO Len(aObjs[1])
      AddColumn( oBrowse, i, aNames[i][CLASS_MEMBER_NAME], 8 )
   NEXT

   // Prfen, ob bestimmte Information verfgbar ist.
   // Wenn ja, hinzufgen in zustzlicher Spalte
   IF IsMethod(aObjs[1], "IsRamsch") == .T.
      oBrowse:AddColumn( {|| BRWDATA(oBrowse)[BRWRECNO(oBrowse)]:IsRamsch()},;
                         2, "Ramsch?" )
   ENDIF

   oBrowse:Show()

RETURN oBrowse


 FUNCTION DoSkip( nSkip, oBrowse )
  LOCAL nCanSkip
  LOCAL nLastRec

   nLastRec := Eval( oBrowse:LastPosBlock )

   IF BRWRECNO(oBrowse) + nSkip < 1             // "BoF"
      nCanSkip := 1 - BRWRECNO(oBrowse)
   ELSEIF BRWRECNO(oBrowse) + nSkip > nLastRec  // "EoF"
      nCanSkip := nLastRec - BRWRECNO(oBrowse)
   ELSE
      nCanSkip := nSkip
   ENDIF

   BRWRECNO(oBrowse) += nCanSkip

RETURN nCanSkip


PROCEDURE AddColumn( oBrowse, nCol, cCaption, nWidth )
 LOCAL nColNo := nCol
   oBrowse:AddColumn( {|| BRWDATA(oBrowse)[BRWRECNO(oBrowse)][nColNo]},;
                      nWidth, cCaption )
RETURN


PROCEDURE DbeSys()
   DbeLoad( "FOXDBE" )
   DbeSetDefault( "FOXDBE" )
RETURN


// Prfen, ob Verkaufspreis des Artikels unter einem
// bestimmten Schwellwert liegt ("Ramschstatus")
FUNCTION CheckRamschStatus( oObj )
RETURN (oObj:SellPrice < 100)

// EOF